package vsp.gaussian;

/**
 * Main class
 * 
 * @author Jan Tichava <jtichava@students.zcu.cz>
 *
 */
public class Vsp {
	
	private final Params params1 = new Params(10000, 10, 5);
	private final Params params2 = new Params(100000, 100, 20);
	
	/**
	 * Creates main object
	 * @param args command line arguments
	 */
	public Vsp(String[] args) {
		try {
			if (args.length > 0) {
				Params params = parseArgs(args);
				RandomGenerator generator = new RandomGenerator(params);
				generator.generate();
			}
			else {
				RandomGenerator generator = new RandomGenerator(params1);
				generator.generate();
				System.out.println("=======================================");
				generator = new RandomGenerator(params2);
				generator.generate();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
	/**
	 * Parse command line arguments
	 * @param args
	 * @return
	 * @throws Exception
	 */
	private Params parseArgs(String[] args) throws Exception {
		if (args.length != 3) {
			throw new Exception("Params are: java -jar Vsp.jar count median deviation");
		}
		
		try {
			return new Params(Integer.valueOf(args[0]), Double.valueOf(args[1]), Double.valueOf(args[2]));
		} catch (NumberFormatException e) {
			throw new Exception("Expectin three double values, error: " + e.getMessage());
		}
	}
	
	/**
	 * main
	 * @param args
	 */
	public static void main(String[] args) {
		new Vsp(args);
	}

}
