package vsp.readConfig;

import java.io.FileNotFoundException;
import java.io.IOException;

import vsp.config.Config;
import vsp.config.ConfigExp;

/**
 * 
 * @author Jan Tichava
 *
 */
public class ReadConfigExp extends ReadConfig {

	/**
	 * Exp config
	 */
	private ConfigExp config;
	
	/**
	 * Creates new exp reader and call parent
	 * 
	 * @param fileName
	 * @throws FileNotFoundException 
	 */
	public ReadConfigExp(String fileName) throws FileNotFoundException {
		super(fileName);
		config = new ConfigExp();
	}
	
	/**
	 * Read config body
	 * 
	 * @param config
	 * @return
	 * @throws NumberFormatException
	 * @throws IOException
	 */
	private ConfigExp readBody(ConfigExp config) throws NumberFormatException, IOException {
		config.setLambdaElectronics(Double.valueOf(readLine()));
		config.setLambdaPaper(Double.valueOf(readLine()));
		
		config.setTs1(Double.valueOf(readLine()));
		config.setTs2(Double.valueOf(readLine()));
		config.setTs3(Double.valueOf(readLine()));
		config.setTs4(Double.valueOf(readLine()));
		
		return config;
	}
	
	/**
	 * Read config file
	 */
	public Config read() throws NumberFormatException, IOException {
		try {
			config = readHead(config);
			config = readBody(config);
		} catch (NullPointerException e) {
			throw new IOException("Error reading config file!");
		}
				
		return (Config) config;
	}

}
