package vsp.config;

/**
 * Interface for simulation configuration
 * 
 * @author Jan Tichava
 *
 */
public interface Config {

	/**
	 * Get probability p1
	 * @return probability p1
	 */
	public double getP1();
	/**
	 * Get probability p2
	 * @return probability p2
	 */
	public double getP2();
	/**
	 * Get probability p3
	 * @return probability p3
	 */
	public double getP3();
	
	/**
	 * Get simulation steps
	 * @return steps
	 */
	public int getSteps();
	/**
	 * Get statistics scanning time
	 * @return
	 */
	public long getScanTime();
	
	/**
	 * Set probability p1
	 * @param p1 probability
	 */
	public void setP1(double p1);
	/**
	 * Set probability p2
	 * @param p2 probability
	 */
	public void setP2(double p2);
	/**
	 * Set probability p3
	 * @param p3 probability
	 */
	public void setP3(double p3);
	
	/**
	 * Set simulation steps
	 * @param steps
	 */
	public void setSteps(int steps);
	/**
	 * Set scanning time
	 * @param scanTime time
	 */
	public void setScanTime(long scanTime);
}
