package vsp.readConfig;

import java.io.FileNotFoundException;
import java.io.IOException;

import vsp.config.Config;
import vsp.config.ConfigGauss;

/**
 * 
 * @author Jan Tichava
 *
 */
public class ReadConfigGauss extends ReadConfig {

	/**
	 * Gauss config
	 */
	private ConfigGauss config;
	
	/**
	 * Creates new Gauss reader and call parent
	 * 
	 * @param fileName
	 * @throws FileNotFoundException 
	 */
	public ReadConfigGauss(String fileName) throws FileNotFoundException {
		super(fileName);
		config = new ConfigGauss();
	}

	/**
	 * Read config body
	 * 
	 * @param config
	 * @return
	 * @throws NumberFormatException
	 * @throws IOException
	 */
	private ConfigGauss readBody(ConfigGauss config) throws NumberFormatException, IOException {
		config.setMiElectronics(Double.valueOf(readLine()));
		config.setSigmaElectronics(Double.valueOf(readLine()));
		
		config.setMiPaper(Double.valueOf(readLine()));
		config.setSigmaPaper(Double.valueOf(readLine()));
		
		config.setMi1(Double.valueOf(readLine()));
		config.setDeviation1(Double.valueOf(readLine()));
		config.setMi2(Double.valueOf(readLine()));
		config.setDeviation2(Double.valueOf(readLine()));
		config.setMi3(Double.valueOf(readLine()));
		config.setDeviation3(Double.valueOf(readLine()));
		config.setMi4(Double.valueOf(readLine()));
		config.setDeviation4(Double.valueOf(readLine()));
		
		return config;
	}
	
	/**
	 * Read config file
	 */
	public Config read() throws NumberFormatException, IOException {
		try {
			config = readHead(config);
			config = readBody(config);
		} catch (NullPointerException e) {
			throw new IOException("Error reading config file!");
		}
		
		return (Config) config;
	}
}
